import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)

/**
 * es una subclase de mundo, en esta se desarrolla todo el juego
 * 
 * @author rene cruz martinez
 * @version 31/05/2010
 */
public class Zona  extends World
{
/**
 * variables para el control de las vidas y los niveles
 */
private int vidas=5;
private int nivel=1;
Counter counter1=new Counter("Puntos: ", 0);
Counter counter2=new Counter("Vidas:  ", vidas);



    /**
     * Constructor for objects of class Zona.
     * 
     */
    public Zona()
    {    
        // Create a new world with 20x20 cells with a cell size of 10x10 pixels.
        super(160, 111, 5);
        setBackground("verde.jpg");
        this.addObject(new Portada(),80,55);    
        this.addObject(new Start(),80,100); 
     
    }
   
    public void incrementaPuntos()
    {
        counter1.add(1);
        
    }
    /**
     * avanza al nuevo nivel del juego, cada vez que es llamado
     * este metodo, 
     * 
     */
    public void cambiaNivel()
    {
        nivel =nivel+1;
        if(nivel==2)
        this.dos();
        if(nivel==3)
        this.tres();
        if(nivel==4)
        this.ganaste();
    
}
/**
 * muestra la ayuda del juego, primero elimina los objetos contenidos en el mundo 
 * y despues muestra la pantalla con la ayuda
 */
public void ayuda()
{
       removeObjects(getObjects(Portada.class));
       removeObjects(getObjects(Start.class));
       this.addObject(new Ayuda(),80,60);    
       
}
/**
 * lo siguientes metodos son llamados cada vez que iniciara elnivel correspondiente a cada uno de ellos 
 * eliminan los objetos contenidos antiriormente, asicomo muestran, un mensaje sobre el nivel al que
 * paso
 */
public void uno()
{
       removeObjects(getObjects(Ayuda.class));
       this.addObject(new Uno(),75,55);
       this.addObject(counter1,10,5);
       this.addObject(counter2,30,5);
       
}
public void dos()
{
       this.eliminaObjetos();
       this.addObject(new Dos(),75,55);
}
public void tres()
{
       this.eliminaObjetos();
       this.addObject(new Tres(),75,55);
}
/**
 * es llamado al momento de que el jugadro culmina el juego
 */
public void ganaste()
{
    this.eliminaObjetos();
    this.addObject(new Ganador(),75,55);


}
/**
 * los siguientes metodos, crean el nuevo nivel al que se paso, agregando los objetos 
 * necesarios para dicho nivel
 */
    public void nivelUno()
    {
          this.eliminaObjetos();
         
          this.addObject(new Manzana(),70,50);
          this.addObject(new Hoyo(),100,50);
          this.addObject(new Hoyo(),90,105);
          this.addObject(new Hoyo(),150,85);
          this.addObject(new Hoyo(),40,110);
          this.addObject(new Hoyo(),70,100);
          this.addObject(new Hoyo(),140,35);
          this.addObject(new FinNivel(),145,60);
          this.addObject(new Arbol(),47,25);
          this.addObject(new Arbol(),60,25);
          this.addObject(new Arbol(),65,95);
          this.addObject(new Arbol(),100,80);
          this.addObject(new Platano(),100,40);
          this.addObject(new Fantasma(),30,20);
          this.addObject(new Fantasma(),60,30);
          this.addObject(new Fantasma(),75,60);
          this.addObject(new Fantasma(),55,90);
          this.addObject(new Fantasma(),100,95);
          this.addObject(new Arquero(),10,50);
        
    }
    public void nivelDos()
    {
      setBackground("text.jpg");
      /*
       * agraga objetos al escenario, de acuerdo al nivel dos
       */
          this.addObject(new Hoyo(),80,55);
          this.addObject(new Hoyo(),105,50);
          this.addObject(new  Manzana(),90,105);
          this.addObject(new Hoyo(),140,85);
          this.addObject(new Hoyo(),45,110);
          this.addObject(new Hoyo(),70,90);
          this.addObject(new Hoyo(),120,115);
          this.addObject(new Hoyo(),145,75);
          this.addObject(new Hoyo(),145,15);
          this.addObject(new FinNivel(),145,60);
          this.addObject(new Arbol(),47,25);
          this.addObject(new Arbol(),60,25);
          this.addObject(new Arbol(),65,95);
          this.addObject(new Arbol(),100,80);
          this.addObject(new Manzana(),100,40);
          this.addObject(new Fantasma(),20,20);
          this.addObject(new Fantasma(),80,30);
          this.addObject(new Cereza(),95,60);
          this.addObject(new Fantasma(),45,90);
          this.addObject(new Fantasma(),100,85);
          this.addObject(new Fantasma2(),40,40);
          this.addObject(new Fantasma2(),90,100);
          this.addObject(new Fantasma2(),115,55);
           this.addObject(new Cereza(),105,55);
          this.addObject(new Arquero(),10,50);
          
       
        
    }
    /**
     * realiza un decremento en el numero de vidas del arquero
     * y dependiendo de numero de vidas es si el juego prosigue 
     * o termina
     */
    public void quitaVida()
    {
        
        counter2.subtract(1);
        vidas--;
        if(vidas==0)
        this.finDelJuego();
    }
   
    public void nivelTres()
    {
        
          setBackground("suelo.jpg");
          this.eliminaObjetos();
          this.addObject(new Hoyo(),70,50);
          this.addObject(new Hoyo(),100,50);
          this.addObject(new Platano(),22,30);
          this.addObject(new Hoyo(),90,105);
          this.addObject(new Hoyo(),150,85);
          this.addObject(new Hoyo(),40,110);
          this.addObject(new Hoyo(),70,100);
          this.addObject(new FinNivel(),145,60);
          this.addObject(new Arbol(),47,25);
          this.addObject(new Platano(),60,25);
          this.addObject(new Arbol(),65,95);
          this.addObject(new Arbol(),100,80);
          this.addObject(new Arbol(),100,40);
          this.addObject(new Fantasma(),30,20);
          this.addObject(new Fantasma(),60,30);
          this.addObject(new Fantasma2(),75,60);
          this.addObject(new Conejo(),100,90);
          this.addObject(new Conejo(),35,70);
          this.addObject(new Conejo(),115,80);
          this.addObject(new Fantasma2(),115,60);
          this.addObject(new Fantasma2(),55,90);
          this.addObject(new Fantasma(),100,95);
          this.addObject(new Arquero(),10,50);
           this.addObject(new Manzana(),115,55);
            this.addObject(new Cereza(),55,55);
               
    }
    /**
     * elimina los objetos contenidos en el mundo 
     */
    
    public void eliminaObjetos()
    {
       removeObjects(getObjects(Fantasma.class));
       removeObjects(getObjects(Fantasma2.class));
       removeObjects(getObjects(Conejo.class));
       removeObjects(getObjects(Arbol.class));
       removeObjects(getObjects(Arquero.class));
       removeObjects(getObjects(Hoyo.class));
       removeObjects(getObjects(FinNivel.class));
       removeObjects(getObjects(Manzana.class));
       removeObjects(getObjects(Platano.class));
       removeObjects(getObjects(Cereza.class));
    }
    /**
     * este metodo elimina los objetos del escenario y 
     * manda un mensaje de fin de juego por haber perdido las vidas 
     * 
     */
    public void finDelJuego()
    {
       this.eliminaObjetos();
       this.addObject(new Perdedor(),75,55);
    }
}
